VERSION 5.00
Begin VB.Form dlgMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "TrapMouse"
   ClientHeight    =   3300
   ClientLeft      =   45
   ClientTop       =   420
   ClientWidth     =   4725
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3300
   ScaleWidth      =   4725
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrm 
      Interval        =   1000
      Left            =   3960
      Top             =   2520
   End
   Begin VB.CommandButton btnmStartNotepad 
      Caption         =   "Start Notepad"
      Height          =   375
      Left            =   2640
      TabIndex        =   0
      Top             =   480
      Width           =   1815
   End
   Begin VB.Label lblmButtonClicked 
      Height          =   255
      Left            =   840
      TabIndex        =   7
      Top             =   2760
      Width           =   3375
   End
   Begin VB.Label lblmControlText 
      Height          =   255
      Left            =   840
      TabIndex        =   6
      Top             =   2040
      Width           =   3255
   End
   Begin VB.Label lblmMousePosition 
      Caption         =   "xxx, yyy"
      Height          =   255
      Left            =   840
      TabIndex        =   5
      Top             =   1440
      Width           =   1575
   End
   Begin VB.Label lblmButtonClickedLabel 
      Caption         =   "Button Clicked:"
      Height          =   255
      Left            =   360
      TabIndex        =   4
      Top             =   2520
      Width           =   1695
   End
   Begin VB.Label lblmControlTextLabel 
      Caption         =   "Control Text:"
      Height          =   255
      Left            =   360
      TabIndex        =   3
      Top             =   1800
      Width           =   1695
   End
   Begin VB.Label lblmMousePositionLabel 
      Caption         =   "Mouse Position:"
      Height          =   255
      Left            =   360
      TabIndex        =   2
      Top             =   1200
      Width           =   1695
   End
   Begin VB.Label lblmDescription 
      Caption         =   "This application monitors Mouse Events in an instance of Notepad."
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   3855
   End
End
Attribute VB_Name = "dlgMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'ShellExecute API is used to launch Notepad.
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
'Constant used in call to ShellExecute
Private Const SW_SHOWNORMAL = 1

'SetActiveWindow API is used to activate an already opened
'instance of Notepad.
Private Declare Function SetActiveWindow Lib "user32" (ByVal hwnd As Long) As Long

'AttachThreadInput API is necessary in order for
'SetActiveWindow API to work.
Private Declare Function AttachThreadInput Lib "user32" (ByVal idAttach As Long, ByVal idAttachTo As Long, ByVal fAttach As Long) As Long



'Object to receive mouse events must be declared at
'class or form level.
Private WithEvents objmMouseEvents As MouseEvents
Attribute objmMouseEvents.VB_VarHelpID = -1

'Number of seconds to wait before giving up
'in Function WaitForWindow
Private lmSeconds As Long

Private Sub btnmStartNotepad_Click()
    Dim objNotepadWindow As Window
    
    'Find the first instance of Notepad to come to hand.
    'This example does not account for the possibility of multiple
    'instances of Notepad being open - only the first one to be
    'found will be monitored.
    Set objNotepadWindow = GetTopLevelWindows.FindWindow("* Notepad", "Notepad")
    
    'If there is no instance of Notepad already running, then
    'start one.
    If objNotepadWindow Is Nothing Then
        If ShellExecute(Me.hwnd, "Open", "Notepad.exe", "", "", SW_SHOWNORMAL) <= 32 Then
            MsgBox "Unable to start Notepad."
            Exit Sub
        Else
            Set objNotepadWindow = WaitForWindow("* Notepad", "Notepad")
            If objNotepadWindow Is Nothing Then
                MsgBox "Timeout expired, waiting for Notepad to open."
                Exit Sub
            End If
        End If
    Else
        'There is already an instance of Notepad running,
        'so switch to that instance.
        AttachThreadInput App.ThreadID, objNotepadWindow.Thread, True
        SetActiveWindow objNotepadWindow
    End If
    
    'Start monitoring Mouse Events
    Set objmMouseEvents = objNotepadWindow.Thread.MouseEvents
End Sub

Private Function WaitForWindow(ByVal sCaption As String, ByVal sClassName As String) As Window
    Dim objWindow As Window
    
    'Wait up to 5 seconds for the specified window to be opened.
    lmSeconds = 5
    While objWindow Is Nothing And lmSeconds > 0
        'DoEvents gives Timer chance to fire its event.
        DoEvents
        Set objWindow = GetTopLevelWindows.FindWindow(sCaption, sClassName)
    Wend
    
    'If the specified window was not opened, then the return
    'value will be Nothing.
    Set WaitForWindow = objWindow
End Function

Private Sub tmrm_Timer()
    lmSeconds = lmSeconds - 1
End Sub

Private Sub objmMouseEvents_MouseEnter(Window As AkemiSpyLibrary.Window)
    'As the mouse pointer enters a window, display
    'the window's caption.
    lblmControlText.Caption = Window.Caption
End Sub

Private Sub objmMouseEvents_MouseLeave(Window As AkemiSpyLibrary.Window)
    'As the mouse pointer leaves a window, clear the
    'control text label.
    lblmControlText.Caption = ""
End Sub

Private Sub objmMouseEvents_MouseMove(Window As AkemiSpyLibrary.Window, ByVal Shift As Boolean, ByVal Control As Boolean, ByVal x As Long, ByVal y As Long)
    'Display the mouse position.  Coordinates are relative
    'to the top-left corner of the window in which the mouse is moving.
    lblmMousePosition.Caption = Format$(x) & ", " & Format$(y)
End Sub

Private Sub objmMouseEvents_Click(Window As AkemiSpyLibrary.Window, ByVal Button As MouseButtonConstants, ByVal Shift As Boolean, ByVal Control As Boolean, ByVal x As Long, ByVal y As Long)
    'If the user clicks on a control, display the caption of that control.
    'Note that if the caption contains an ampersand (&), the letter
    'after the ampersand will be underlined to indicate a keyboard
    'accelerator.
    lblmButtonClicked.Caption = Window.Caption
End Sub


